<?php
	/* function menulayout
	 * Takes 6 arguments and outputs a HTML navigation menu 
	 * $forward = link to "next page", i.e. "nextPage.html"
	 * $backward = link to "previous page", i.e. "previousPage.html"
	 * $downloadlink = link to download source file, on download button, i.e. "sourceFile.txt"
	 * headinglink = link in heading, i.e. "sourceFile.txt"
	 * filecontent = file containing info in the left panel, i.e. "panelContent.txt"
	*/
	function menulayout($forward,$backward,$downloadlink,$heading,$headinglink,$filecontent) {
		if($backward != ""){
			$backwardButton = "<a href='".$backward."'><img src='CodeViewerLeftbutton.png'></a>";
		}else{
			$backwardButton = "<img src='CodeViewerLeftbuttonGrayed.png'>";
		}

		if($forward != ""){
			$forwardButton = "<a href='".$forward."'><img src='CodeViewerRightbutton.png'></a>";
		}else{
			$forwardButton = "<img src='CodeViewerLeftbuttonGrayed.png'>";
		}

		if($downloadlink != ""){
			$downloadButton = "<a href='".$downloadlink."'><img src='CodeViewerDownloadbutton.png'></a>";
		}else{
			$downloadButton = "<img src='CodeViewerLeftbuttonGrayed.png'>";
		}

		?>
		<body onload='resize();' onresize='resize();'>
			<div class='Topmenu'>
				<table style='width:100%;height:100%;border:solid 1px;'>
					<tr>
						<td class="buttonstyle">
							<?=$backwardButton;?>
						</td>
						<td class='buttonstyle'>
							<?=$forwardButton;?>
						</td>
						<td class="buttonstyle">
							<a href='../Lindex.html'><img src='CodeViewerRightbutton.png'></a>
						</td>
						<td class="verticalaligntext">
							<a href="<?=$headinglink;?>" style="text-decoration: none"><?=$heading;?></a>
						</td>
						<td class='buttonstyle'>
							<?=$downloadButton;?>
						</td>
					</tr>
				</table>
			</div>
			<div id="bottom" class="restContainer">
				<div style="float: left;">
					<div id="panel" class="panel" onmousemove='resizepanel(event)' onmousedown='mdpanel(event)' onmouseup='mupanel(event)'>
						<?php include($filecontent); ?>
					</div>
				</div>
				<div class="codecontent">
		<?php
	}

	/* function menulayoutend
	 * Outputs ending tags in HTML
	 */
	function menulayoutend() {
		?>
				</div>
			</div>
			<div style="clear: both;"></div>
		</body>
		<?php
	}

	/* function showfile 
	 * Outputs html with syntax highlighting.
	 * Takes 4 arguments_
	 * interestingrows: array containing arrays, each with 3 set values -- start line number, end line number, comment
	 * keywords: array containing keywords 
	 * highlight: array containing arrays, each with two values - string to highlight, and HTML class to apply to highlight */
	function showfile($interestingrows,$keywords,$highlight,$filename) {
		echo "<pre>";
		$handle = @fopen($filename, "r");
		if ($handle) {

			$lineno = 1;
			$commentkind = 0;
			$commenton = 0;

			while (($buffer = fgets($handle, 4096)) !== false) {
				$buffer = str_replace("\n","", $buffer);
				$buffer = str_replace("\r","", $buffer);
				$buffer=str_pad($buffer,150," ", STR_PAD_RIGHT);
				$buffer=str_replace("&","&amp;",$buffer);
				$buffer=str_replace("<","&lt;",$buffer);
				$buffer=str_replace(">","&gt;",$buffer);
				$buffer=str_replace("\t","&nbsp;",$buffer);

				$interesting = 0;
				$startspan = 0;
				foreach($interestingrows as $row){
					if($lineno >= $row[0] && $lineno <= $row[1]){
						$interesting = true;
					}
				}

				foreach($keywords as $keyword){
					if($interesting){
						$buffer = str_replace($keyword,"<span class='keywordinteresting'>".$keyword."</span>", $buffer);
					}else{
						$buffer = str_replace($keyword,"<span class='keyword'>".$keyword."</span>", $buffer);
					}
				}

				// Detect comments - 0 == No comment 1 == Line comment 2 == Start Comment 3 == End Comment
				$commentkind = 0;
				$commentpos = strpos($buffer,"/*");

				if($commentpos >= 0){
					$subby = substr($buffer,$commentpos+2,1);
				}else{
					$subby = "Foo";
				}

				if($commentpos && $subby != '"'){
					$commentkind = 2;
					$commenton = 1;
				}							

				$commentpos = strpos($buffer,"*/");

				if($commentpos){
					$commentkind = 3;
					$commenton = 0;
				}							

				$commentpos=strpos($buffer,"//");

				if($commentpos){
					$commentkind = 1;
					$commenton = 0;
				}							

				foreach($highlight as $highlightkeyword){
					$foundpos = strpos($buffer, $highlightkeyword[0]);

					// If line comment and keyword before comment marker
					if(($foundpos <= $commentpos && ($commentkind == 1 || $commentkind == 2)) || ($commentkind == 0) || ($foundpos > $commentpos && $commentkind == 3)) {
						if(!($commentkind==0&&$commenton==1)) {
							$buffer = str_replace($highlightkeyword[0],"<span class='".$highlightkeyword[1]."'>".$highlightkeyword[0]."</span>",$buffer);
						}
					}

				}

				// echo $commentkind.$commenton;
				if($commentkind > 0){
					if($commentkind == 1){
						$buffer = str_replace("//","<span class='commented'>//",$buffer);
						$buffer .= "</span>";
					}
					if($commentkind==2) {
						$buffer=str_replace("/*","<span class='commented'>/*",$buffer);
					} 
					if($commentkind==3) {
						$buffer=str_replace("*/","*/</span>",$buffer);
					}
				}

				$linenostr = $lineno;
				$linenostr = str_pad($linenostr,3," ",STR_PAD_RIGHT);
				
				if($interesting){
					echo "<span class='interesting'>";
					echo "<span class='linenointeresting'>".$linenostr."</span>&nbsp;";
					$startspan = 1;
				} else {
					echo "<span class='lineno'>".$linenostr."</span>&nbsp;";				
				}
				
				echo $buffer;
				
				if($startspan) {
					echo "</span>";
				}
				
				$lineno++;
				echo "<br>";
			}
			if (!feof($handle)) {
				echo "Error: unexpected fgets() fail\n";
			}
			fclose($handle);
		}
		echo "</pre>";	
	}
?>